class PromptEncoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  embed_dim : int
  input_image_size : Tuple[int, int]
  image_embedding_size : Tuple[int, int]
  pe_layer : __torch__.d2go.projects.sam.model.decoder.sam_decoder.PositionEmbeddingRandom
  invalid_points : __torch__.torch.nn.modules.sparse.Embedding
  point_embeddings : __torch__.torch.nn.modules.sparse.Embedding
  bbox_top_left_embeddings : __torch__.torch.nn.modules.sparse.Embedding
  bbox_bottom_right_embeddings : __torch__.torch.nn.modules.sparse.Embedding
  def forward(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PromptEncoder,
    coords: Tensor,
    labels: Tensor) -> Tensor:
    _0 = (self)._embed_points(coords, labels, )
    return _0
  def _embed_points(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PromptEncoder,
    points: Tensor,
    labels: Tensor) -> Tensor:
    points0 = torch.add(points, 0.5)
    pe_layer = self.pe_layer
    input_image_size = self.input_image_size
    point_embedding = (pe_layer).forward_with_coords(points0, input_image_size, )
    _1 = torch.eq(labels, -1)
    invalid_points = self.invalid_points
    weight = invalid_points.weight
    _2 = annotate(List[Optional[Tensor]], [_1])
    _3 = torch.add_(torch.index(point_embedding, _2), weight)
    _4 = torch.index_put_(point_embedding, _2, _3)
    _5 = torch.eq(labels, 1)
    point_embeddings = self.point_embeddings
    weight0 = point_embeddings.weight
    _6 = annotate(List[Optional[Tensor]], [_5])
    _7 = torch.add_(torch.index(point_embedding, _6), weight0)
    _8 = torch.index_put_(point_embedding, _6, _7)
    _9 = torch.eq(labels, 2)
    bbox_top_left_embeddings = self.bbox_top_left_embeddings
    weight1 = bbox_top_left_embeddings.weight
    _10 = annotate(List[Optional[Tensor]], [_9])
    _11 = torch.add_(torch.index(point_embedding, _10), weight1)
    _12 = torch.index_put_(point_embedding, _10, _11)
    _13 = torch.eq(labels, 3)
    bbox_bottom_right_embeddings = self.bbox_bottom_right_embeddings
    weight2 = bbox_bottom_right_embeddings.weight
    _14 = annotate(List[Optional[Tensor]], [_13])
    _15 = torch.add_(torch.index(point_embedding, _14), weight2)
    _16 = torch.index_put_(point_embedding, _14, _15)
    return point_embedding
  def get_dense_pe(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PromptEncoder) -> Tensor:
    pe_layer = self.pe_layer
    image_embedding_size = self.image_embedding_size
    _17 = (pe_layer).forward(image_embedding_size, )
    return torch.unsqueeze(_17, 0)
class PositionEmbeddingRandom(Module):
  __parameters__ = []
  __buffers__ = ["positional_encoding_gaussian_matrix", ]
  positional_encoding_gaussian_matrix : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  def forward(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PositionEmbeddingRandom,
    size: Tuple[int, int]) -> Tensor:
    h, w, = size
    positional_encoding_gaussian_matrix = self.positional_encoding_gaussian_matrix
    device = ops.prim.device(positional_encoding_gaussian_matrix)
    grid = torch.ones([h, w], dtype=6, layout=None, device=device)
    y_embed = torch.sub(torch.cumsum(grid, 0), 0.5)
    x_embed = torch.sub(torch.cumsum(grid, 1), 0.5)
    y_embed0 = torch.div(y_embed, h)
    x_embed0 = torch.div(x_embed, w)
    _18 = torch.stack([x_embed0, y_embed0], -1)
    pe = (self)._pe_encoding(_18, )
    return torch.permute(pe, [2, 0, 1])
  def _pe_encoding(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PositionEmbeddingRandom,
    coords: Tensor) -> Tensor:
    coords0 = torch.sub(torch.mul(coords, 2), 1)
    positional_encoding_gaussian_matrix = self.positional_encoding_gaussian_matrix
    coords1 = torch.matmul(coords0, positional_encoding_gaussian_matrix)
    coords2 = torch.mul(coords1, 6.2831853071795862)
    _19 = [torch.sin(coords2), torch.cos(coords2)]
    return torch.cat(_19, -1)
  def forward_with_coords(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.PositionEmbeddingRandom,
    coords_input: Tensor,
    image_size: Tuple[int, int]) -> Tensor:
    coords = torch.clone(coords_input)
    _20 = torch.select(torch.slice(torch.slice(coords), 1), 2, 0)
    _21 = torch.div(_20, (image_size)[1])
    _22 = torch.select(torch.slice(torch.slice(coords), 1), 2, 0)
    _23 = torch.copy_(_22, _21)
    _24 = torch.select(torch.slice(torch.slice(coords), 1), 2, 1)
    _25 = torch.div(_24, (image_size)[0])
    _26 = torch.select(torch.slice(torch.slice(coords), 1), 2, 1)
    _27 = torch.copy_(_26, _25)
    _28 = (self)._pe_encoding(torch.to(coords, 6), )
    return _28
class MaskDecoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  transformer_dim : int
  num_multimask_outputs : int
  num_mask_tokens : int
  use_post_unet_pe : bool
  transformer : __torch__.d2go.projects.sam.model.sam.TwoWayTransformer
  iou_token : __torch__.torch.nn.modules.sparse.Embedding
  mask_tokens : __torch__.torch.nn.modules.sparse.___torch_mangle_19.Embedding
  unet_upscaling_layers : __torch__.torch.nn.modules.container.___torch_mangle_20.ModuleList
  pe_layer_post_unet : __torch__.d2go.projects.sam.model.decoder.sam_decoder.PositionEmbeddingRandom
  final_output_upscaling_layers : __torch__.torch.nn.modules.container.___torch_mangle_24.ModuleList
  output_hypernetworks_mlps : __torch__.torch.nn.modules.container.___torch_mangle_29.ModuleList
  iou_prediction_head : __torch__.d2go.projects.sam.model.mlp.___torch_mangle_31.MLPBlock
  def forward(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.MaskDecoder,
    image_embeddings: List[Tensor],
    image_pe: Tensor,
    sparse_prompt_embeddings: Tensor,
    multimask_output: bool) -> Tuple[Tensor, Tensor]:
    _29 = torch.size(sparse_prompt_embeddings)
    batch_size, max_num_queries, sparse_embed_dim_1, sparse_embed_dim_2, = _29
    _30 = annotate(List[Tensor], [])
    for _31 in range(torch.len(image_embeddings)):
      image_embedding = image_embeddings[_31]
      _32, image_embed_dim_c, image_embed_dim_h, image_embed_dim_w, = torch.size(image_embedding)
      _33 = torch.eq((torch.size(image_embedding))[0], batch_size)
      if _33:
        _34 = torch.unsqueeze(torch.slice(image_embedding), 1)
        _35 = torch.slice(torch.slice(_34, 2), 3)
        _36 = torch.tile(torch.slice(_35, 4), [1, max_num_queries, 1, 1, 1])
        _37 = torch.mul(batch_size, max_num_queries)
        _38 = [_37, image_embed_dim_c, image_embed_dim_h, image_embed_dim_w]
        image_embedding_tiled = torch.view(_36, _38)
      else:
        image_embedding_tiled = image_embedding
      _39 = torch.append(_30, image_embedding_tiled)
    _40 = torch.mul(batch_size, max_num_queries)
    _41 = [_40, sparse_embed_dim_1, sparse_embed_dim_2]
    sparse_prompt_embeddings0 = torch.reshape(sparse_prompt_embeddings, _41)
    _42 = (self).predict_masks(_30, image_pe, sparse_prompt_embeddings0, )
    masks, iou_pred, = _42
    if multimask_output:
      num_multimask_outputs = self.num_multimask_outputs
      _44 = torch.gt(num_multimask_outputs, 1)
      _43 = _44
    else:
      _43 = False
    if _43:
      _46 = torch.slice(torch.slice(masks), 1, 1)
      _47 = torch.slice(_46, 2)
      _48 = torch.slice(torch.slice(iou_pred), 1, 1)
      _45 = (_47, _48)
    else:
      _49 = torch.slice(torch.slice(masks), 1, None, 1)
      _50 = torch.slice(_49, 2)
      _51 = torch.slice(torch.slice(iou_pred), 1, None, 1)
      _45 = (_50, _51)
    return _45
  def predict_masks(self: __torch__.d2go.projects.sam.model.decoder.sam_decoder.MaskDecoder,
    image_embeddings: List[Tensor],
    image_pe: Tensor,
    sparse_prompt_embeddings: Tensor) -> Tuple[Tensor, Tensor]:
    iou_token = self.iou_token
    weight = iou_token.weight
    mask_tokens = self.mask_tokens
    weight3 = mask_tokens.weight
    _52 = torch.cat([weight, weight3])
    _53 = ops.prim.device(sparse_prompt_embeddings)
    output_tokens = torch.to(_52, _53)
    _54 = torch.unsqueeze(output_tokens, 0)
    _55 = torch.size(sparse_prompt_embeddings, 0)
    output_tokens0 = torch.expand(_54, [_55, -1, -1])
    _56 = [output_tokens0, sparse_prompt_embeddings]
    tokens = torch.cat(_56, 1)
    _57 = torch.tensor((torch.size(tokens))[0])
    _58 = torch.to(_57, ops.prim.device(image_pe))
    pos_src = torch.repeat_interleave(image_pe, _58, 0)
    final_image_embedding = image_embeddings[-1]
    b, c, h, w, = torch.size(final_image_embedding)
    transformer = self.transformer
    _59 = (transformer).forward(final_image_embedding, pos_src, tokens, )
    hs, src, = _59
    iou_token_out = torch.slice(torch.select(torch.slice(hs), 1, 0), 1)
    _60 = torch.slice(hs)
    num_mask_tokens = self.num_mask_tokens
    _61 = torch.slice(_60, 1, 1, torch.add(1, num_mask_tokens))
    mask_tokens_out = torch.slice(_61, 2)
    upscaled_embedding = torch.view(torch.transpose(src, 1, 2), [b, c, h, w])
    use_post_unet_pe = self.use_post_unet_pe
    if use_post_unet_pe:
      b0, c0, h0, w0, = torch.size(upscaled_embedding)
      pe_layer_post_unet = self.pe_layer_post_unet
      _62 = (pe_layer_post_unet).forward((h0, w0), )
      pe_post_unet = torch.unsqueeze(_62, 0)
      pe_post_unet0 = torch.repeat_interleave(pe_post_unet, b0, 0)
      upscaled_embedding1 = torch.add(upscaled_embedding, pe_post_unet0)
      upscaled_embedding0 = upscaled_embedding1
    else:
      upscaled_embedding0 = upscaled_embedding
    final_output_upscaling_layers = self.final_output_upscaling_layers
    _0 = getattr(final_output_upscaling_layers, "0")
    _1 = getattr(final_output_upscaling_layers, "1")
    upscaled_embedding2 = (_0).forward(upscaled_embedding0, )
    upscaled_embedding3 = (_1).forward(upscaled_embedding2, )
    hyper_in_list = annotate(List[Tensor], [])
    output_hypernetworks_mlps = self.output_hypernetworks_mlps
    _00 = getattr(output_hypernetworks_mlps, "0")
    _10 = getattr(output_hypernetworks_mlps, "1")
    _2 = getattr(output_hypernetworks_mlps, "2")
    _3 = getattr(output_hypernetworks_mlps, "3")
    _63 = torch.select(torch.slice(mask_tokens_out), 1, 0)
    _64 = (_00).forward(torch.slice(_63, 1), )
    _65 = torch.append(hyper_in_list, _64)
    _66 = torch.select(torch.slice(mask_tokens_out), 1, 1)
    _67 = (_10).forward(torch.slice(_66, 1), )
    _68 = torch.append(hyper_in_list, _67)
    _69 = torch.select(torch.slice(mask_tokens_out), 1, 2)
    _70 = torch.append(hyper_in_list, (_2).forward(torch.slice(_69, 1), ))
    _71 = torch.select(torch.slice(mask_tokens_out), 1, 3)
    _72 = torch.append(hyper_in_list, (_3).forward(torch.slice(_71, 1), ))
    hyper_in = torch.stack(hyper_in_list, 1)
    b1, c1, h1, w1, = torch.size(upscaled_embedding3)
    _73 = torch.view(upscaled_embedding3, [b1, c1, torch.mul(h1, w1)])
    masks = torch.view(torch.matmul(hyper_in, _73), [b1, -1, h1, w1])
    iou_prediction_head = self.iou_prediction_head
    iou_pred = (iou_prediction_head).forward(iou_token_out, )
    return (masks, iou_pred)
