class Sam(Module):
  __parameters__ = []
  __buffers__ = ["pixel_mean", "pixel_std", ]
  pixel_mean : Tensor
  pixel_std : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  decoder_max_num_input_points : int
  fusion_type : str
  user_input_circle_radius : float
  H : int
  W : int
  image_encoder : __torch__.d2go.projects.sam.model.encoder.sam_encoder.ImageEncoderViT
  prompt_encoder : __torch__.d2go.projects.sam.model.decoder.sam_decoder.PromptEncoder
  mask_decoder : __torch__.d2go.projects.sam.model.decoder.sam_decoder.MaskDecoder
  def __device_getter(self: __torch__.d2go.projects.sam.model.sam.Sam) -> Any:
    pixel_mean = self.pixel_mean
    _0 = unchecked_cast(Any, ops.prim.device(pixel_mean))
    return _0
  def forward(self: __torch__.d2go.projects.sam.model.sam.Sam,
    batched_images: Tensor,
    batched_points: Tensor,
    batched_point_labels: Tensor) -> Tuple[Tensor, Tensor]:
    fusion_type = self.fusion_type
    if torch.eq(fusion_type, "early"):
      _1 = True
    else:
      fusion_type0 = self.fusion_type
      _1 = torch.eq(fusion_type0, "hybrid")
    if _1:
      image_embeddings0 = (self).get_image_embeddings_with_early_fusion(batched_images, batched_points, batched_point_labels, )
      image_embeddings = image_embeddings0
    else:
      image_embeddings1 = (self).get_image_embeddings(batched_images, )
      image_embeddings = image_embeddings1
    H = self.H
    W = self.W
    _2 = (self).predict_masks(image_embeddings, batched_points, batched_point_labels, True, H, W, )
    return _2
  def add_user_inputs_as_separate_channels(self: __torch__.d2go.projects.sam.model.sam.Sam,
    batched_images: Tensor,
    batched_points: Tensor,
    batched_point_labels: Tensor) -> Tensor:
    _3 = "AssertionError: preprocess must be called before calling this function."
    H = self.H
    if torch.gt(H, 0):
      W = self.W
      _4 = torch.gt(W, 0)
    else:
      _4 = False
    if _4:
      pass
    else:
      ops.prim.RaiseException(_3)
    rescaled_batched_points = (self).get_rescaled_pts(batched_points, )
    batch_size, _5, h, w, = torch.size(batched_images)
    max_num_queries = (torch.size(rescaled_batched_points))[1]
    device = ops.prim.device(batched_images)
    row_ids = torch.to(torch.arange(h), device)
    col_ids = torch.to(torch.arange(w), device)
    _6 = torch.reshape(row_ids, [1, 1, h, 1])
    row_ids0 = torch.tile(_6, [batch_size, max_num_queries, 1, w])
    _7 = torch.reshape(col_ids, [1, 1, 1, w])
    col_ids0 = torch.tile(_7, [batch_size, max_num_queries, h, 1])
    _8 = torch.slice(torch.slice(batched_point_labels), 1)
    is_bbox = torch.to(torch.ne(torch.select(_8, 2, 0), 1), 6)
    _9 = torch.slice(rescaled_batched_points)
    _10 = torch.slice(torch.slice(_9, 1), 2, None, 2)
    _11, _12 = torch.min(torch.select(_10, 3, 0), -1)
    top_left_x = torch.mul(is_bbox, _11)
    _13 = torch.slice(rescaled_batched_points)
    _14 = torch.slice(torch.slice(_13, 1), 2, None, 2)
    _15, _16 = torch.min(torch.select(_14, 3, 1), -1)
    top_left_y = torch.mul(is_bbox, _15)
    _17 = torch.slice(rescaled_batched_points)
    _18 = torch.slice(torch.slice(_17, 1), 2, None, 2)
    _19, _20 = torch.max(torch.select(_18, 3, 0), -1)
    _21 = torch.mul(is_bbox, _19)
    _22 = torch.mul(torch.add(torch.neg(is_bbox), 1), w)
    bottom_right_x = torch.add(_21, _22)
    _23 = torch.slice(rescaled_batched_points)
    _24 = torch.slice(torch.slice(_23, 1), 2, None, 2)
    _25, _26 = torch.max(torch.select(_24, 3, 1), -1)
    _27 = torch.mul(is_bbox, _25)
    _28 = torch.mul(torch.add(torch.neg(is_bbox), 1), h)
    bottom_right_y = torch.add(_27, _28)
    _29 = torch.unsqueeze(torch.unsqueeze(top_left_y, -1), -1)
    _30 = torch.ge(row_ids0, _29)
    _31 = torch.unsqueeze(torch.unsqueeze(bottom_right_y, -1), -1)
    row_within = torch.logical_and(_30, torch.le(row_ids0, _31))
    _32 = torch.unsqueeze(torch.unsqueeze(top_left_x, -1), -1)
    _33 = torch.ge(col_ids0, _32)
    _34 = torch.unsqueeze(torch.unsqueeze(bottom_right_x, -1), -1)
    col_within = torch.logical_and(_33, torch.le(col_ids0, _34))
    bbox_mask = torch.logical_and(row_within, col_within)
    _35 = torch.to(torch.eq(batched_point_labels, 1), 6)
    _36 = torch.unsqueeze(torch.slice(torch.slice(_35), 1), 2)
    is_point = torch.slice(torch.unsqueeze(_36, 3), 4)
    cols_and_rows = torch.stack([col_ids0, row_ids0], -1)
    user_input_circle_radius = self.user_input_circle_radius
    _37 = torch.slice(torch.slice(cols_and_rows), 1)
    _38 = torch.unsqueeze(torch.slice(torch.slice(_37, 2), 3), 4)
    _39 = torch.slice(_38, 5)
    _40 = torch.slice(rescaled_batched_points)
    _41 = torch.unsqueeze(torch.slice(_40, 1), 2)
    _42 = torch.slice(torch.unsqueeze(_41, 3), 4)
    _43 = torch.square(torch.sub(_39, torch.slice(_42, 5)))
    _44 = torch.mul(torch.sum(_43, [-1]), is_point)
    _45 = torch.add(torch.neg(is_point), 1)
    _46 = torch.mul(user_input_circle_radius, user_input_circle_radius)
    _47 = torch.add(_44, torch.mul(_45, torch.add(_46, 1)))
    _48, _49 = torch.min(_47, -1)
    _50 = torch.mul(user_input_circle_radius, user_input_circle_radius)
    user_input_pts_mask = torch.le(_48, _50)
    _51 = torch.unsqueeze(torch.slice(batched_images), 1)
    _52 = torch.slice(torch.slice(torch.slice(_51, 2), 3), 4)
    batched_images0 = torch.tile(_52, [1, max_num_queries, 1, 1, 1])
    _53 = torch.slice(torch.slice(bbox_mask), 1)
    _54 = torch.slice(torch.unsqueeze(_53, 2), 3)
    _55 = torch.slice(_54, 4)
    _56 = torch.slice(torch.slice(user_input_pts_mask), 1)
    _57 = torch.slice(torch.unsqueeze(_56, 2), 3)
    _58 = [batched_images0, _55, torch.slice(_57, 4)]
    return torch.cat(_58, 2)
  def get_image_embeddings(self: __torch__.d2go.projects.sam.model.sam.Sam,
    batched_images: Tensor) -> List[Tensor]:
    batched_images1 = (self).preprocess(batched_images, )
    image_encoder = self.image_encoder
    _59 = (image_encoder).forward(batched_images1, )
    return _59
  def get_image_embeddings_with_early_fusion(self: __torch__.d2go.projects.sam.model.sam.Sam,
    batched_images: Tensor,
    batched_points: Tensor,
    batched_point_labels: Tensor) -> List[Tensor]:
    batched_images2 = (self).preprocess(batched_images, )
    batch_size, _60, H, W, = torch.size(batched_images2)
    max_num_queries = (torch.size(batched_points))[1]
    batched_images3 = (self).add_user_inputs_as_separate_channels(batched_images2, batched_points, batched_point_labels, )
    _61 = torch.mul(batch_size, max_num_queries)
    batched_images4 = torch.reshape(batched_images3, [_61, 5, H, W])
    image_encoder = self.image_encoder
    _62 = (image_encoder).forward(batched_images4, )
    return _62
  def predict_masks(self: __torch__.d2go.projects.sam.model.sam.Sam,
    image_embeddings: List[Tensor],
    batched_points: Tensor,
    batched_point_labels: Tensor,
    multimask_output: bool,
    output_h: int=-1,
    output_w: int=-1) -> Tuple[Tensor, Tensor]:
    _63 = __torch__.torch.nn.functional.___torch_mangle_32.interpolate
    batch_size, max_num_queries, num_pts, _64, = torch.size(batched_points)
    num_pts0 = (torch.size(batched_points))[2]
    rescaled_batched_points = (self).get_rescaled_pts(batched_points, )
    decoder_max_num_input_points = self.decoder_max_num_input_points
    _65 = torch.gt(num_pts0, decoder_max_num_input_points)
    if _65:
      _66 = torch.slice(rescaled_batched_points)
      _67 = torch.slice(_66, 1)
      decoder_max_num_input_points0 = self.decoder_max_num_input_points
      _68 = torch.slice(_67, 2, None, decoder_max_num_input_points0)
      rescaled_batched_points1 = torch.slice(_68, 3)
      _69 = torch.slice(torch.slice(batched_point_labels), 1)
      decoder_max_num_input_points1 = self.decoder_max_num_input_points
      batched_point_labels1 = torch.slice(_69, 2, None, decoder_max_num_input_points1)
      rescaled_batched_points0, batched_point_labels0 = rescaled_batched_points1, batched_point_labels1
    else:
      decoder_max_num_input_points2 = self.decoder_max_num_input_points
      _70 = torch.lt(num_pts0, decoder_max_num_input_points2)
      if _70:
        decoder_max_num_input_points3 = self.decoder_max_num_input_points
        _71 = torch.sub(decoder_max_num_input_points3, num_pts0)
        rescaled_batched_points3 = torch.pad(rescaled_batched_points, [0, 0, 0, _71], "constant", -1.)
        decoder_max_num_input_points4 = self.decoder_max_num_input_points
        _72 = torch.sub(decoder_max_num_input_points4, num_pts0)
        batched_point_labels3 = torch.pad(batched_point_labels, [0, _72], "constant", -1.)
        rescaled_batched_points2, batched_point_labels2 = rescaled_batched_points3, batched_point_labels3
      else:
        rescaled_batched_points2, batched_point_labels2 = rescaled_batched_points, batched_point_labels
      rescaled_batched_points0, batched_point_labels0 = rescaled_batched_points2, batched_point_labels2
    prompt_encoder = self.prompt_encoder
    _73 = torch.mul(batch_size, max_num_queries)
    decoder_max_num_input_points5 = self.decoder_max_num_input_points
    _74 = [_73, decoder_max_num_input_points5, 2]
    _75 = torch.view(rescaled_batched_points0, _74)
    _76 = torch.mul(batch_size, max_num_queries)
    decoder_max_num_input_points6 = self.decoder_max_num_input_points
    _77 = [_76, decoder_max_num_input_points6]
    _78 = torch.view(batched_point_labels0, _77)
    sparse_embeddings = (prompt_encoder).forward(_75, _78, )
    _79 = [batch_size, max_num_queries, (torch.size(sparse_embeddings))[1], (torch.size(sparse_embeddings))[2]]
    sparse_embeddings0 = torch.view(sparse_embeddings, _79)
    mask_decoder = self.mask_decoder
    prompt_encoder0 = self.prompt_encoder
    _80 = (prompt_encoder0).get_dense_pe()
    _81 = ops.prim.device(image_embeddings[-1])
    _82 = (mask_decoder).forward(image_embeddings, torch.to(_80, _81), sparse_embeddings0, multimask_output, )
    low_res_masks, iou_predictions, = _82
    _83, num_predictions, low_res_size, _84, = torch.size(low_res_masks)
    if torch.gt(output_w, 0):
      _85 = torch.gt(output_h, 0)
    else:
      _85 = False
    if _85:
      output_masks0 = _63(low_res_masks, [output_h, output_w], None, "bicubic", None, None, False, )
      _86 = [batch_size, max_num_queries, num_predictions, output_h, output_w]
      output_masks = torch.reshape(output_masks0, _86)
    else:
      _87 = [batch_size, max_num_queries, num_predictions, low_res_size, low_res_size]
      output_masks = torch.reshape(low_res_masks, _87)
    _88 = [batch_size, max_num_queries, num_predictions]
    _89 = (output_masks, torch.reshape(iou_predictions, _88))
    return _89
  def preprocess(self: __torch__.d2go.projects.sam.model.sam.Sam,
    x: Tensor) -> Tensor:
    _90 = __torch__.torch.nn.functional.___torch_mangle_32.interpolate
    _91 = torch.item(torch.tensor((torch.size(x))[2]))
    self.H = int(_91)
    _92 = torch.item(torch.tensor((torch.size(x))[3]))
    self.W = int(_92)
    H = self.H
    image_encoder = self.image_encoder
    img_size = image_encoder.img_size
    if torch.ne(H, img_size):
      _93 = True
    else:
      W = self.W
      image_encoder0 = self.image_encoder
      img_size0 = image_encoder0.img_size
      _93 = torch.ne(W, img_size0)
    if _93:
      image_encoder1 = self.image_encoder
      img_size1 = image_encoder1.img_size
      image_encoder2 = self.image_encoder
      img_size2 = image_encoder2.img_size
      x1 = _90(x, [img_size1, img_size2], None, "bilinear", None, None, False, )
      x0 = x1
    else:
      x0 = x
    pixel_mean = self.pixel_mean
    _94 = torch.sub(x0, pixel_mean)
    pixel_std = self.pixel_std
    return torch.div(_94, pixel_std)
  def get_rescaled_pts(self: __torch__.d2go.projects.sam.model.sam.Sam,
    batched_points: Tensor) -> Tensor:
    _95 = "AssertionError: preprocess must be called before calling this function."
    H = self.H
    if torch.gt(H, 0):
      W = self.W
      _96 = torch.gt(W, 0)
    else:
      _96 = False
    if _96:
      pass
    else:
      ops.prim.RaiseException(_95)
    _97 = torch.ge(torch.select(batched_points, -1, 0), 0)
    _98 = torch.select(batched_points, -1, 0)
    image_encoder = self.image_encoder
    img_size = image_encoder.img_size
    _99 = torch.mul(_98, img_size)
    W0 = self.W
    _100 = torch.where(_97, torch.div(_99, W0), -1.)
    _101 = torch.ge(torch.select(batched_points, -1, 1), 0)
    _102 = torch.select(batched_points, -1, 1)
    image_encoder3 = self.image_encoder
    img_size3 = image_encoder3.img_size
    _103 = torch.mul(_102, img_size3)
    H0 = self.H
    _104 = torch.where(_101, torch.div(_103, H0), -1.)
    return torch.stack([_100, _104], -1)
class TwoWayTransformer(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  depth : int
  embedding_dim : int
  num_heads : int
  mlp_dim : int
  layers : __torch__.torch.nn.modules.container.___torch_mangle_18.ModuleList
  final_attn_token_to_image : __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock
  norm_final_attn : __torch__.torch.nn.modules.normalization.___torch_mangle_11.LayerNorm
  def forward(self: __torch__.d2go.projects.sam.model.sam.TwoWayTransformer,
    image_embedding: Tensor,
    image_pe: Tensor,
    point_embedding: Tensor) -> Tuple[Tensor, Tensor]:
    image_embedding0 = torch.permute(torch.flatten(image_embedding, 2), [0, 2, 1])
    image_pe0 = torch.permute(torch.flatten(image_pe, 2), [0, 2, 1])
    layers = self.layers
    _0 = getattr(layers, "0")
    _1 = getattr(layers, "1")
    _105 = (_0).forward(point_embedding, image_embedding0, point_embedding, image_pe0, )
    queries, keys, = _105
    _106 = (_1).forward(queries, keys, point_embedding, image_pe0, )
    queries0, keys0, = _106
    q = torch.add(queries0, point_embedding)
    k = torch.add(keys0, image_pe0)
    final_attn_token_to_image = self.final_attn_token_to_image
    attn_out = (final_attn_token_to_image).forward(q, k, keys0, )
    queries1 = torch.add(queries0, attn_out)
    norm_final_attn = self.norm_final_attn
    queries2 = (norm_final_attn).forward(queries1, )
    return (queries2, keys0)
class TwoWayAttentionBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  skip_first_layer_pe : bool
  self_attn : __torch__.d2go.projects.sam.model.sam.AttentionForTwoWayAttentionBlock
  norm1 : __torch__.torch.nn.modules.normalization.___torch_mangle_11.LayerNorm
  dropout1 : __torch__.torch.nn.modules.dropout.___torch_mangle_9.Dropout
  cross_attn_token_to_image : __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock
  norm2 : __torch__.torch.nn.modules.normalization.___torch_mangle_11.LayerNorm
  dropout2 : __torch__.torch.nn.modules.dropout.___torch_mangle_9.Dropout
  quant_input_mlp : __torch__.torch.ao.quantization.stubs.QuantStub
  mlp : __torch__.d2go.projects.sam.model.mlp.MLPBlock
  dequant_output_mlp : __torch__.torch.ao.quantization.stubs.DeQuantStub
  norm3 : __torch__.torch.nn.modules.normalization.___torch_mangle_11.LayerNorm
  dropout3 : __torch__.torch.nn.modules.dropout.___torch_mangle_9.Dropout
  norm4 : __torch__.torch.nn.modules.normalization.___torch_mangle_11.LayerNorm
  cross_attn_image_to_token : __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock
  def forward(self: __torch__.d2go.projects.sam.model.sam.TwoWayAttentionBlock,
    queries: Tensor,
    keys: Tensor,
    query_pe: Tensor,
    key_pe: Tensor) -> Tuple[Tensor, Tensor]:
    skip_first_layer_pe = self.skip_first_layer_pe
    if torch.__not__(skip_first_layer_pe):
      queries3 = torch.add(queries, query_pe)
    else:
      queries3 = queries
    self_attn = self.self_attn
    attn_out = (self_attn).forward(queries3, queries3, queries3, )
    dropout1 = self.dropout1
    queries4 = torch.add(queries3, (dropout1).forward(attn_out, ))
    norm1 = self.norm1
    queries5 = (norm1).forward(queries4, )
    q = torch.add(queries5, query_pe)
    k = torch.add(keys, key_pe)
    cross_attn_token_to_image = self.cross_attn_token_to_image
    attn_out0 = (cross_attn_token_to_image).forward(q, k, keys, )
    dropout2 = self.dropout2
    queries6 = torch.add(queries5, (dropout2).forward(attn_out0, ))
    norm2 = self.norm2
    queries7 = (norm2).forward(queries6, )
    dequant_output_mlp = self.dequant_output_mlp
    mlp = self.mlp
    quant_input_mlp = self.quant_input_mlp
    _107 = (quant_input_mlp).forward(queries7, )
    mlp_out = (dequant_output_mlp).forward((mlp).forward(_107, ), )
    dropout3 = self.dropout3
    queries8 = torch.add(queries7, (dropout3).forward(mlp_out, ))
    norm3 = self.norm3
    queries9 = (norm3).forward(queries8, )
    q0 = torch.add(queries9, query_pe)
    k0 = torch.add(keys, key_pe)
    cross_attn_image_to_token = self.cross_attn_image_to_token
    attn_out1 = (cross_attn_image_to_token).forward(k0, q0, queries9, )
    keys1 = torch.add(keys, attn_out1)
    norm4 = self.norm4
    keys2 = (norm4).forward(keys1, )
    return (queries9, keys2)
class AttentionForTwoWayAttentionBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  embedding_dim : int
  internal_dim : int
  num_heads : int
  q_proj : __torch__.torch.nn.modules.linear.___torch_mangle_8.Linear
  q_dropout : __torch__.torch.nn.modules.dropout.Dropout
  k_proj : __torch__.torch.nn.modules.linear.___torch_mangle_8.Linear
  k_dropout : __torch__.torch.nn.modules.dropout.Dropout
  v_proj : __torch__.torch.nn.modules.linear.___torch_mangle_8.Linear
  v_dropout : __torch__.torch.nn.modules.dropout.Dropout
  attn_dropout : __torch__.torch.nn.modules.dropout.___torch_mangle_9.Dropout
  out_proj : __torch__.torch.nn.modules.linear.___torch_mangle_10.Linear
  out_dropout : __torch__.torch.nn.modules.dropout.Dropout
  quant_q : __torch__.torch.ao.quantization.stubs.QuantStub
  quant_k : __torch__.torch.ao.quantization.stubs.QuantStub
  quant_v : __torch__.torch.ao.quantization.stubs.QuantStub
  dequant_q : __torch__.torch.ao.quantization.stubs.DeQuantStub
  dequant_k : __torch__.torch.ao.quantization.stubs.DeQuantStub
  dequant_v : __torch__.torch.ao.quantization.stubs.DeQuantStub
  def forward(self: __torch__.d2go.projects.sam.model.sam.AttentionForTwoWayAttentionBlock,
    q: Tensor,
    k: Tensor,
    v: Tensor) -> Tensor:
    q_dropout = self.q_dropout
    q_proj = self.q_proj
    quant_q = self.quant_q
    _108 = (q_proj).forward((quant_q).forward(q, ), )
    q1 = (q_dropout).forward(_108, )
    k_dropout = self.k_dropout
    k_proj = self.k_proj
    quant_k = self.quant_k
    _109 = (k_proj).forward((quant_k).forward(k, ), )
    k1 = (k_dropout).forward(_109, )
    v_dropout = self.v_dropout
    v_proj = self.v_proj
    quant_v = self.quant_v
    _110 = (v_proj).forward((quant_v).forward(v, ), )
    v0 = (v_dropout).forward(_110, )
    num_heads = self.num_heads
    q2 = (self)._separate_heads(q1, num_heads, )
    num_heads0 = self.num_heads
    k2 = (self)._separate_heads(k1, num_heads0, )
    num_heads1 = self.num_heads
    v1 = (self)._separate_heads(v0, num_heads1, )
    dequant_q = self.dequant_q
    q3 = (dequant_q).forward(q2, )
    dequant_k = self.dequant_k
    k3 = (dequant_k).forward(k2, )
    dequant_v = self.dequant_v
    v2 = (dequant_v).forward(v1, )
    _111, _112, _113, c_per_head, = torch.size(q3)
    attn = torch.matmul(q3, torch.permute(k3, [0, 1, 3, 2]))
    attn0 = torch.div(attn, torch.sqrt(c_per_head))
    attn1 = torch.softmax(attn0, -1)
    attn_dropout = self.attn_dropout
    attn2 = (attn_dropout).forward(attn1, )
    out = torch.matmul(attn2, v2)
    out0 = (self)._recombine_heads(out, )
    out_dropout = self.out_dropout
    out_proj = self.out_proj
    out1 = (out_dropout).forward((out_proj).forward(out0, ), )
    return out1
  def _separate_heads(self: __torch__.d2go.projects.sam.model.sam.AttentionForTwoWayAttentionBlock,
    x: Tensor,
    num_heads: int) -> Tensor:
    b, n, c, = torch.size(x)
    _114 = [b, n, num_heads, torch.floordiv(c, num_heads)]
    x2 = torch.reshape(x, _114)
    return torch.transpose(x2, 1, 2)
  def _recombine_heads(self: __torch__.d2go.projects.sam.model.sam.AttentionForTwoWayAttentionBlock,
    x: Tensor) -> Tensor:
    b, n_heads, n_tokens, c_per_head, = torch.size(x)
    x3 = torch.transpose(x, 1, 2)
    _115 = [b, n_tokens, torch.mul(n_heads, c_per_head)]
    return torch.reshape(x3, _115)
