class AttentionForTwoWayAttentionBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  embedding_dim : int
  internal_dim : int
  num_heads : int
  q_proj : __torch__.torch.nn.modules.linear.___torch_mangle_12.Linear
  q_dropout : __torch__.torch.nn.modules.dropout.Dropout
  k_proj : __torch__.torch.nn.modules.linear.___torch_mangle_12.Linear
  k_dropout : __torch__.torch.nn.modules.dropout.Dropout
  v_proj : __torch__.torch.nn.modules.linear.___torch_mangle_12.Linear
  v_dropout : __torch__.torch.nn.modules.dropout.Dropout
  attn_dropout : __torch__.torch.nn.modules.dropout.___torch_mangle_9.Dropout
  out_proj : __torch__.torch.nn.modules.linear.___torch_mangle_13.Linear
  out_dropout : __torch__.torch.nn.modules.dropout.Dropout
  quant_q : __torch__.torch.ao.quantization.stubs.QuantStub
  quant_k : __torch__.torch.ao.quantization.stubs.QuantStub
  quant_v : __torch__.torch.ao.quantization.stubs.QuantStub
  dequant_q : __torch__.torch.ao.quantization.stubs.DeQuantStub
  dequant_k : __torch__.torch.ao.quantization.stubs.DeQuantStub
  dequant_v : __torch__.torch.ao.quantization.stubs.DeQuantStub
  def forward(self: __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock,
    q: Tensor,
    k: Tensor,
    v: Tensor) -> Tensor:
    q_dropout = self.q_dropout
    q_proj = self.q_proj
    quant_q = self.quant_q
    _0 = (q_proj).forward((quant_q).forward(q, ), )
    q0 = (q_dropout).forward(_0, )
    k_dropout = self.k_dropout
    k_proj = self.k_proj
    quant_k = self.quant_k
    _1 = (k_proj).forward((quant_k).forward(k, ), )
    k0 = (k_dropout).forward(_1, )
    v_dropout = self.v_dropout
    v_proj = self.v_proj
    quant_v = self.quant_v
    _2 = (v_proj).forward((quant_v).forward(v, ), )
    v0 = (v_dropout).forward(_2, )
    num_heads = self.num_heads
    q1 = (self)._separate_heads(q0, num_heads, )
    num_heads0 = self.num_heads
    k1 = (self)._separate_heads(k0, num_heads0, )
    num_heads1 = self.num_heads
    v1 = (self)._separate_heads(v0, num_heads1, )
    dequant_q = self.dequant_q
    q2 = (dequant_q).forward(q1, )
    dequant_k = self.dequant_k
    k2 = (dequant_k).forward(k1, )
    dequant_v = self.dequant_v
    v2 = (dequant_v).forward(v1, )
    _3, _4, _5, c_per_head, = torch.size(q2)
    attn = torch.matmul(q2, torch.permute(k2, [0, 1, 3, 2]))
    attn0 = torch.div(attn, torch.sqrt(c_per_head))
    attn1 = torch.softmax(attn0, -1)
    attn_dropout = self.attn_dropout
    attn2 = (attn_dropout).forward(attn1, )
    out = torch.matmul(attn2, v2)
    out0 = (self)._recombine_heads(out, )
    out_dropout = self.out_dropout
    out_proj = self.out_proj
    out1 = (out_dropout).forward((out_proj).forward(out0, ), )
    return out1
  def _separate_heads(self: __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock,
    x: Tensor,
    num_heads: int) -> Tensor:
    b, n, c, = torch.size(x)
    _6 = [b, n, num_heads, torch.floordiv(c, num_heads)]
    x0 = torch.reshape(x, _6)
    return torch.transpose(x0, 1, 2)
  def _recombine_heads(self: __torch__.d2go.projects.sam.model.sam.___torch_mangle_14.AttentionForTwoWayAttentionBlock,
    x: Tensor) -> Tensor:
    b, n_heads, n_tokens, c_per_head, = torch.size(x)
    x1 = torch.transpose(x, 1, 2)
    _7 = [b, n_tokens, torch.mul(n_heads, c_per_head)]
    return torch.reshape(x1, _7)
