class VitDetPatchEmbed(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  img_size : Tuple[int, int]
  patch_size : Tuple[int, int]
  grid_size : Tuple[int, int]
  num_patches : int
  flatten : bool
  proj : __torch__.torch.nn.modules.conv.Conv2d
  norm : __torch__.torch.nn.modules.linear.Identity
  def forward(self: __torch__.mobile_cv.arch.fbnet_v2.fb.vit_det_blocks.VitDetPatchEmbed,
    x: Tensor) -> Tensor:
    proj = self.proj
    x0 = (proj).forward(x, )
    flatten = self.flatten
    if flatten:
      x2 = torch.transpose(torch.flatten(x0, 2), 1, 2)
      x1 = x2
    else:
      x1 = x0
    norm = self.norm
    return (norm).forward(x1, )
class Block(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  window_size : int
  use_residual_block : bool
  norm1 : __torch__.torch.nn.modules.normalization.LayerNorm
  attn : __torch__.mobile_cv.arch.fbnet_v2.fb.vit_det_utils.Attention
  drop_path : __torch__.torch.nn.modules.linear.Identity
  norm2 : __torch__.torch.nn.modules.normalization.LayerNorm
  mlp : __torch__.timm.models.layers.mlp.Mlp
  def forward(self: __torch__.mobile_cv.arch.fbnet_v2.fb.vit_det_blocks.Block,
    x: Tensor) -> Tensor:
    norm1 = self.norm1
    x3 = (norm1).forward(x, )
    attn = self.attn
    x4 = (attn).forward(x3, )
    drop_path = self.drop_path
    x5 = torch.add(x, (drop_path).forward(x4, ))
    drop_path0 = self.drop_path
    mlp = self.mlp
    norm2 = self.norm2
    _0 = (mlp).forward((norm2).forward(x5, ), )
    x6 = torch.add(x5, (drop_path0).forward(_0, ))
    return x6
