def layer_norm(input: Tensor,
    normalized_shape: List[int],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _0 = torch.layer_norm(input, normalized_shape, weight, bias, eps)
  return _0
def dropout(input: Tensor,
    p: float=0.5,
    training: bool=True,
    inplace: bool=False) -> Tensor:
  _1 = "dropout probability has to be between 0 and 1, but got {}"
  if torch.lt(p, 0.):
    _2 = True
  else:
    _2 = torch.gt(p, 1.)
  if _2:
    ops.prim.RaiseException(torch.format(_1, p), "builtins.ValueError")
  else:
    pass
  if inplace:
    _3 = torch.dropout_(input, p, training)
  else:
    _3 = torch.dropout(input, p, training)
  return _3
def embedding(input: Tensor,
    weight: Tensor,
    padding_idx: Optional[int]=None,
    max_norm: Optional[float]=None,
    norm_type: float=2.,
    scale_grad_by_freq: bool=False,
    sparse: bool=False) -> Tensor:
  _4 = "AssertionError: Padding_idx must be within num_embeddings"
  if torch.__isnot__(padding_idx, None):
    padding_idx1 = unchecked_cast(int, padding_idx)
    if torch.gt(padding_idx1, 0):
      _5 = torch.lt(padding_idx1, torch.size(weight, 0))
      if _5:
        pass
      else:
        ops.prim.RaiseException(_4)
      padding_idx2 = padding_idx1
    else:
      if torch.lt(padding_idx1, 0):
        _6 = torch.neg(torch.size(weight, 0))
        if torch.ge(padding_idx1, _6):
          pass
        else:
          ops.prim.RaiseException(_4)
        padding_idx4 = torch.add(torch.size(weight, 0), padding_idx1)
        padding_idx3 = padding_idx4
      else:
        padding_idx3 = padding_idx1
      padding_idx2 = padding_idx3
    padding_idx0 = padding_idx2
  else:
    padding_idx0 = -1
  if torch.__isnot__(max_norm, None):
    input0 = torch.contiguous(input)
  else:
    input0 = input
  _7 = torch.embedding(weight, input0, padding_idx0, scale_grad_by_freq, sparse)
  return _7
def group_norm(input: Tensor,
    num_groups: int,
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _8 = "Expected at least 2 dimensions for input tensor but received {}"
  _9 = __torch__.torch.nn.functional._verify_batch_size
  if torch.lt(torch.dim(input), 2):
    ops.prim.RaiseException(torch.format(_8, torch.dim(input)), "builtins.RuntimeError")
  else:
    pass
  _10 = torch.mul(torch.size(input, 0), torch.size(input, 1))
  _11 = [torch.floordiv(_10, num_groups), num_groups]
  _12 = torch.list(torch.slice(torch.size(input), 2))
  _13 = _9(torch.add(_11, _12), )
  _14 = torch.group_norm(input, num_groups, weight, bias, eps)
  return _14
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _15 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _15:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _16 = torch.adaptive_avg_pool2d(input, output_size)
  return _16
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _17 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _17:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _18 = torch.adaptive_avg_pool3d(input, output_size)
  return _18
def _verify_batch_size(size: List[int]) -> NoneType:
  _19 = "Expected more than 1 value per channel when training, got input size {}"
  size_prods = size[0]
  size_prods0 = size_prods
  for i in range(torch.sub(torch.len(size), 2)):
    size_prods1 = torch.mul(size_prods0, size[torch.add(i, 2)])
    size_prods0 = size_prods1
  if torch.eq(size_prods0, 1):
    ops.prim.RaiseException(torch.format(_19, size), "builtins.ValueError")
  else:
    pass
  return None
