def interpolate(input: Tensor,
    size: Optional[List[int]]=None,
    scale_factor: Optional[List[float]]=None,
    mode: str="nearest",
    align_corners: Optional[bool]=None,
    recompute_scale_factor: Optional[bool]=None,
    antialias: bool=False) -> Tensor:
  _0 = "align_corners option can only be set with the interpolating modes: linear | bilinear | bicubic | trilinear"
  _1 = "only one of size or scale_factor should be defined"
  _2 = "Input and output must have the same number of spatial dimensions, but got input with spatial dimensions of {} and output size of {}. Please provide input tensor in (N, C, d1, d2, ...,dK) format and output size in (o1, o2, ...,oK) format."
  _3 = "Input and scale_factor must have the same number of spatial dimensions, but got input with spatial dimensions of {} and scale_factor of shape {}. Please provide input tensor in (N, C, d1, d2, ...,dK) format and scale_factor in (s1, s2, ...,sK) format."
  _4 = "either size or scale_factor should be defined"
  _5 = "recompute_scale_factor is not meaningful with an explicit size."
  _6 = "Anti-alias option is only supported for bilinear and bicubic modes"
  _7 = __torch__.torch.nn.functional.adaptive_avg_pool2d
  _8 = __torch__.torch.nn.functional.adaptive_avg_pool3d
  _9 = "Got 3D input, but bilinear mode needs 4D input"
  _10 = "Got 3D input, but trilinear mode needs 5D input"
  _11 = "Got 4D input, but linear mode needs 3D input"
  _12 = "Got 4D input, but trilinear mode needs 5D input"
  _13 = "Got 5D input, but linear mode needs 3D input"
  _14 = "Got 5D input, but bilinear mode needs 4D input"
  _15 = "Input Error: Only 3D, 4D and 5D input Tensors supported (got {}D) for the modes: nearest | linear | bilinear | bicubic | trilinear | area | nearest-exact (got {})"
  _16 = uninitialized(Tensor)
  _17 = uninitialized(List[int])
  _18 = uninitialized(Optional[bool])
  _19 = uninitialized(NoneType)
  _20 = uninitialized(List[float])
  _21 = uninitialized(Optional[List[int]])
  _22 = uninitialized(Optional[List[float]])
  _23 = uninitialized(Optional[List[int]])
  _24 = uninitialized(Optional[bool])
  _25 = uninitialized(bool)
  _26 = torch.__contains__(["nearest", "area", "nearest-exact"], mode)
  if _26:
    _27 = torch.__isnot__(align_corners, None)
    if _27:
      ops.prim.RaiseException(_0, "builtins.ValueError")
      align_corners1 : Optional[bool] = _24
    else:
      align_corners1 = align_corners
    align_corners0 : Optional[bool] = align_corners1
  else:
    if torch.__is__(align_corners, None):
      align_corners2 = False
    else:
      align_corners3 = unchecked_cast(bool, align_corners)
      align_corners2 = align_corners3
    align_corners0 = align_corners2
  dim = torch.sub(torch.dim(input), 2)
  if torch.__isnot__(size, None):
    size1 = unchecked_cast(List[int], size)
    _28, size0 = torch.__isnot__(scale_factor, None), size1
  else:
    _28, size0 = False, size
  if _28:
    ops.prim.RaiseException(_1, "builtins.ValueError")
    size2, output_size, scale_factors = _23, _21, _22
  else:
    if torch.__isnot__(size0, None):
      size4 = unchecked_cast(List[int], size0)
      if torch.__is__(scale_factor, None):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      size5 = unchecked_cast(List[int], size4)
      if torch.ne(torch.len(size5), dim):
        _29 = torch.slice(torch.size(input), 2)
        _30 = torch.format(_2, torch.list(_29), size5)
        ops.prim.RaiseException(_30, "builtins.ValueError")
      else:
        pass
      size3, output_size0, scale_factors0 = size5, size5, None
    else:
      _31 = torch.__isnot__(scale_factor, None)
      if _31:
        scale_factor0 = unchecked_cast(List[float], scale_factor)
        if torch.__is__(size0, None):
          size7 : Optional[List[int]] = size0
        else:
          ops.prim.RaiseException("AssertionError: ")
          size7 = _23
        scale_factor1 = unchecked_cast(List[float], scale_factor0)
        _32 = torch.ne(torch.len(scale_factor1), dim)
        if _32:
          _33 = torch.slice(torch.size(input), 2)
          _34 = torch.format(_3, torch.list(_33), scale_factor1)
          ops.prim.RaiseException(_34, "builtins.ValueError")
        else:
          pass
        size6, output_size1, scale_factors1 = size7, None, scale_factor1
      else:
        ops.prim.RaiseException(_4, "builtins.ValueError")
        size6, output_size1, scale_factors1 = _23, _19, _20
      size3, output_size0, scale_factors0 = size6, output_size1, scale_factors1
    size2, output_size, scale_factors = size3, output_size0, scale_factors0
  _35 = torch.__isnot__(recompute_scale_factor, None)
  if _35:
    recompute_scale_factor1 = unchecked_cast(bool, recompute_scale_factor)
    _36, recompute_scale_factor0 = recompute_scale_factor1, recompute_scale_factor1
  else:
    _36, recompute_scale_factor0 = False, recompute_scale_factor
  if _36:
    recompute_scale_factor3 = unchecked_cast(bool, recompute_scale_factor0)
    _37, recompute_scale_factor2 = torch.__isnot__(size2, None), recompute_scale_factor3
  else:
    _37, recompute_scale_factor2 = False, recompute_scale_factor0
  if _37:
    ops.prim.RaiseException(_5, "builtins.ValueError")
    recompute_scale_factor4 : Optional[bool] = _18
  else:
    recompute_scale_factor4 = recompute_scale_factor2
  if torch.eq(mode, "area"):
    _38 = torch.__is__(output_size, None)
  else:
    _38 = False
  if _38:
    recompute_scale_factor5 : Optional[bool] = True
  else:
    recompute_scale_factor5 = recompute_scale_factor4
  _39 = torch.__isnot__(recompute_scale_factor5, None)
  if _39:
    recompute_scale_factor6 = unchecked_cast(bool, recompute_scale_factor5)
    _40 = recompute_scale_factor6
  else:
    _40 = False
  if _40:
    _41 = torch.__isnot__(scale_factors, None)
    if _41:
      scale_factors4 = unchecked_cast(List[float], scale_factors)
      scale_factors3 = scale_factors4
    else:
      ops.prim.RaiseException("AssertionError: ")
      scale_factors3 = _20
    output_size3 = annotate(List[int], [])
    for i in range(dim):
      _42 = torch.size(input, torch.add(i, 2))
      _43 = torch.mul(float(_42), scale_factors3[i])
      _44 = torch.append(output_size3, torch.floor(_43))
    output_size2, scale_factors2 = output_size3, None
  else:
    output_size2, scale_factors2 = output_size, scale_factors
  if antialias:
    _46 = torch.__contains__(["bilinear", "bicubic"], mode)
    if _46:
      _47 = torch.eq(torch.dim(input), 4)
    else:
      _47 = False
    _45 = torch.__not__(_47)
  else:
    _45 = False
  if _45:
    ops.prim.RaiseException(_6, "builtins.ValueError")
  else:
    pass
  if torch.eq(torch.dim(input), 3):
    _48 = torch.eq(mode, "nearest")
  else:
    _48 = False
  if _48:
    _50 = torch.upsample_nearest1d(input, output_size2, scale_factors2)
    _49 = _50
  else:
    if torch.eq(torch.dim(input), 4):
      _51 = torch.eq(mode, "nearest")
    else:
      _51 = False
    if _51:
      _53 = torch.upsample_nearest2d(input, output_size2, scale_factors2)
      _52 = _53
    else:
      if torch.eq(torch.dim(input), 5):
        _54 = torch.eq(mode, "nearest")
      else:
        _54 = False
      if _54:
        _56 = torch.upsample_nearest3d(input, output_size2, scale_factors2)
        _55 = _56
      else:
        if torch.eq(torch.dim(input), 3):
          _58 = torch.eq(mode, "nearest-exact")
          _57 = _58
        else:
          _57 = False
        if _57:
          _60 = torch._upsample_nearest_exact1d(input, output_size2, scale_factors2)
          _59 = _60
        else:
          if torch.eq(torch.dim(input), 4):
            _62 = torch.eq(mode, "nearest-exact")
            _61 = _62
          else:
            _61 = False
          if _61:
            _64 = torch._upsample_nearest_exact2d(input, output_size2, scale_factors2)
            _63 = _64
          else:
            _65 = torch.eq(torch.dim(input), 5)
            if _65:
              _67 = torch.eq(mode, "nearest-exact")
              _66 = _67
            else:
              _66 = False
            if _66:
              _69 = torch._upsample_nearest_exact3d(input, output_size2, scale_factors2)
              _68 = _69
            else:
              _70 = torch.eq(torch.dim(input), 3)
              if _70:
                _71 = torch.eq(mode, "area")
              else:
                _71 = False
              if _71:
                _73 = torch.__isnot__(output_size2, None)
                if _73:
                  output_size5 = unchecked_cast(List[int], output_size2)
                  output_size4 = output_size5
                else:
                  ops.prim.RaiseException("AssertionError: ")
                  output_size4 = _17
                _74 = torch.adaptive_avg_pool1d(input, output_size4)
                _72 = _74
              else:
                _75 = torch.eq(torch.dim(input), 4)
                if _75:
                  _77 = torch.eq(mode, "area")
                  _76 = _77
                else:
                  _76 = False
                if _76:
                  _79 = torch.__isnot__(output_size2, None)
                  if _79:
                    output_size7 = unchecked_cast(List[int], output_size2)
                    output_size6 = output_size7
                  else:
                    ops.prim.RaiseException("AssertionError: ")
                    output_size6 = _17
                  _80 = _7(input, output_size6, )
                  _78 = _80
                else:
                  _81 = torch.eq(torch.dim(input), 5)
                  if _81:
                    _83 = torch.eq(mode, "area")
                    _82 = _83
                  else:
                    _82 = False
                  if _82:
                    _85 = torch.__isnot__(output_size2, None)
                    if _85:
                      output_size9 = unchecked_cast(List[int], output_size2)
                      output_size8 = output_size9
                    else:
                      ops.prim.RaiseException("AssertionError: ")
                      output_size8 = _17
                    _86 = _8(input, output_size8, )
                    _84 = _86
                  else:
                    _87 = torch.eq(torch.dim(input), 3)
                    if _87:
                      _89 = torch.eq(mode, "linear")
                      _88 = _89
                    else:
                      _88 = False
                    if _88:
                      _91 = torch.__isnot__(align_corners0, None)
                      if _91:
                        align_corners5 = unchecked_cast(bool, align_corners0)
                        align_corners4 = align_corners5
                      else:
                        ops.prim.RaiseException("AssertionError: ")
                        align_corners4 = _25
                      _92 = torch.upsample_linear1d(input, output_size2, align_corners4, scale_factors2)
                      _90 = _92
                    else:
                      _93 = torch.eq(torch.dim(input), 4)
                      if _93:
                        _95 = torch.eq(mode, "bilinear")
                        _94 = _95
                      else:
                        _94 = False
                      if _94:
                        _97 = torch.__isnot__(align_corners0, None)
                        if _97:
                          align_corners7 = unchecked_cast(bool, align_corners0)
                          align_corners6 = align_corners7
                        else:
                          ops.prim.RaiseException("AssertionError: ")
                          align_corners6 = _25
                        if antialias:
                          _99 = torch._upsample_bilinear2d_aa(input, output_size2, align_corners6, scale_factors2)
                          _98 = _99
                        else:
                          _100 = torch.upsample_bilinear2d(input, output_size2, align_corners6, scale_factors2)
                          _98 = _100
                        _96 = _98
                      else:
                        _101 = torch.dim(input)
                        _102 = torch.eq(_101, 5)
                        if _102:
                          _104 = torch.eq(mode, "trilinear")
                          _103 = _104
                        else:
                          _103 = False
                        if _103:
                          _106 = torch.__isnot__(align_corners0, None)
                          if _106:
                            align_corners9 = unchecked_cast(bool, align_corners0)
                            align_corners8 = align_corners9
                          else:
                            ops.prim.RaiseException("AssertionError: ")
                            align_corners8 = _25
                          _107 = torch.upsample_trilinear3d(input, output_size2, align_corners8, scale_factors2)
                          _105 = _107
                        else:
                          _108 = torch.dim(input)
                          _109 = torch.eq(_108, 4)
                          if _109:
                            _111 = torch.eq(mode, "bicubic")
                            _110 = _111
                          else:
                            _110 = False
                          if _110:
                            _113 = torch.__isnot__(align_corners0, None)
                            if _113:
                              align_corners11 = unchecked_cast(bool, align_corners0)
                              align_corners10 = align_corners11
                            else:
                              ops.prim.RaiseException("AssertionError: ")
                              align_corners10 = _25
                            if antialias:
                              _115 = torch._upsample_bicubic2d_aa(input, output_size2, align_corners10, scale_factors2)
                              _114 = _115
                            else:
                              _116 = torch.upsample_bicubic2d(input, output_size2, align_corners10, scale_factors2)
                              _114 = _116
                            _112 = _114
                          else:
                            _117 = torch.dim(input)
                            _118 = torch.eq(_117, 3)
                            if _118:
                              _120 = torch.eq(mode, "bilinear")
                              _119 = _120
                            else:
                              _119 = False
                            if _119:
                              ops.prim.RaiseException(_9, "builtins.NotImplementedError")
                            else:
                              pass
                            _121 = torch.dim(input)
                            _122 = torch.eq(_121, 3)
                            if _122:
                              _124 = torch.eq(mode, "trilinear")
                              _123 = _124
                            else:
                              _123 = False
                            if _123:
                              ops.prim.RaiseException(_10, "builtins.NotImplementedError")
                            else:
                              pass
                            _125 = torch.dim(input)
                            _126 = torch.eq(_125, 4)
                            if _126:
                              _128 = torch.eq(mode, "linear")
                              _127 = _128
                            else:
                              _127 = False
                            if _127:
                              ops.prim.RaiseException(_11, "builtins.NotImplementedError")
                            else:
                              pass
                            _129 = torch.dim(input)
                            _130 = torch.eq(_129, 4)
                            if _130:
                              _132 = torch.eq(mode, "trilinear")
                              _131 = _132
                            else:
                              _131 = False
                            if _131:
                              ops.prim.RaiseException(_12, "builtins.NotImplementedError")
                            else:
                              pass
                            _133 = torch.dim(input)
                            _134 = torch.eq(_133, 5)
                            if _134:
                              _136 = torch.eq(mode, "linear")
                              _135 = _136
                            else:
                              _135 = False
                            if _135:
                              ops.prim.RaiseException(_13, "builtins.NotImplementedError")
                            else:
                              pass
                            _137 = torch.dim(input)
                            _138 = torch.eq(_137, 5)
                            if _138:
                              _140 = torch.eq(mode, "bilinear")
                              _139 = _140
                            else:
                              _139 = False
                            if _139:
                              ops.prim.RaiseException(_14, "builtins.NotImplementedError")
                            else:
                              pass
                            _141 = torch.dim(input)
                            _142 = torch.format(_15, _141, mode)
                            ops.prim.RaiseException(_142, "builtins.NotImplementedError")
                            _112 = _16
                          _105 = _112
                        _96 = _105
                      _90 = _96
                    _84 = _90
                  _78 = _84
                _72 = _78
              _68 = _72
            _63 = _68
          _59 = _63
        _55 = _59
      _52 = _55
    _49 = _52
  return _49
